#
# -*- coding: utf-8 -*-
#
# Copyright European Organization for Nuclear Research (CERN)
# All rights reserved
#
# Please look at the supplied documentation for the user's
# license
#
# Author: Vasilis.Vlachoudis@cern.ch
# Date:   04-Oct-2012

__author__ = "Vasilis Vlachoudis"
__email__  = "Vasilis.Vlachoudis@cern.ch"

import tkinter as tk

import icons
import tkExtra

import Ribbon
import FlairRibbon

#===============================================================================
# Empty frame class
#===============================================================================
class EmptyPage(FlairRibbon.FlairPage):
	"""Empty page for flair"""

	_name_ = "Empty"
	_icon_ = "empty"

	#----------------------------------------------------------------------
	def createRibbon(self):
		super().createRibbon()

		# ========== Plot List ===========
		group = Ribbon.LabelGroup(self.ribbon, "Empty")
		group.pack(side=tk.LEFT, fill=tk.Y, padx=0, pady=0)

		group.frame.grid_rowconfigure(0, weight=1)
		col,row = 0,0
		b = Ribbon.LabelButton(group.frame, image=icons.get("clean32"),
				text="Clear",
				compound=tk.TOP,
				#command=self.clear,
				background=Ribbon._BACKGROUND)
		b.grid(row=row, column=col, padx=0, pady=0, sticky=tk.NSEW)
		tkExtra.Balloon.set(b, "Clear")

	#----------------------------------------------------------------------
	def createPage(self):
		super().createPage()

	# ----------------------------------------------------------------------
	# Refresh
	# ----------------------------------------------------------------------
	def refresh(self, what=None):
		super().refresh(what)

	# ----------------------------------------------------------------------
	# Update fields
	# ----------------------------------------------------------------------
	def get(self, event=None):
		if self.page is None or self.project is None: return
		#self.modified()
