#!/usr/bin/python
# -*- coding: utf-8 -*-
#
# Author:	Vasilis.Vlachoudis@cern.ch
# Date:	01-Nov-2017
#from __future__ import print_function

__author__   = "Vasilis Vlachoudis"
__email__    = "Vasilis.Vlachoudis@cern.ch"

import os
import glob
import tkinter as tk

import log

# global dictionary of icons
_icons = {}
_zoom  = 1

# base64.encodebytes(open("save.gif","rb").read())
__def_icons = {
	"newfolder" : """
		R0lGODlhEAAQAMZcABAQECEQECEYEDEgITEwIUI4MVJJQmNJIWNZQmNhWvw/Afw+DnNhUvxADv9B
		D3NlSoRpIZRxIYRxUvRbM4R5Y6V5IfxhHvpnGvlsAZSCY7WCEPFwM5SKc5yKa5SKhPJ4QMaKENaK
		EMaSAJyShPqDHqWShNaSAOuDZdaSEP+BSaWahP+LPqWilLWihLWilOWWfueiIeeiMbWqlP+ZauKg
		itaqUveqMcaylOCql9ayc/eyMca6lN20o/e6QtbDhNbDlPfDQv+8i87Htf/DUs7LtefLhP/LUv/Q
		Lv/RMf/TUufTpf/TY/fThP/Tc//bY/fbhP/bc//bhPfjlP/jhP/jlPfrpf3rlP/rpffzpffztf/z
		pf31xf//////////////////////////////////////////////////////////////////////
		/////////////////////////////////////////////////////////////////////////yH5
		BAEKAH8ALAAAAAAQABAAAAe6gH+Cg4SFhoU4PIeFCjgKJy+KgjKUlEKCCgokDYMySllZWlcuRBYY
		W1YXE4IuWKFXV1AsKitIRx+DLlWiV1FOTkEOKRsLNIIsVbA3N5QtLTMnJSUeHCpSV0UyU9vcU1BQ
		NSPWVDI7UL9OS0lGPTEPfyVP2VNN6UtGQD06EB3wTDI/oCy5N0SfjRAHBHnwoe0ePh02YKCAkEAQ
		Bxc5TGgUAUKDhgoRElrMQEECAwQGChAYIABAgEUwBQUCADs=
		""",

	"select_all" : """
		R0lGODdhDwAPAOMJAEKW70qi92Oy/8bn/87r/9bv/97v/97z/+f3////////////////////////
		/////ywAAAAADwAPAAAESVDISasIIINw9ZYAIiKAEI6leRDEUQJrmwLGMBhvfc9FX7y+nwSj4RAz
		HItycvw0kyfRa0QCxVwqFtakw3FtXlMQ6Es9O8XlMgIAOw==
		""",

	"select_none" : """
		R0lGODdhDgAOAMIEAK2urc7Lzu/v7/f39////////////////ywAAAAADgAOAAADMDi63AEwqBcV
		IBhYTPS4QreF3pVt50ABkgqxTSzPzNraqPhxJUGOOlOQN3ndjLRYAgA7
		""",

	"select_invert" : """
		R0lGODdhEAAQAOMNAEKW70qi92Oy/62urc7Lzsbn/87r/9bv/97v/+/v797z/+f3//f39///////
		/////ywAAAAAEAAQAAAEXpDJKYW9lpHBSQ1ACAQCMzToUAFLuwDlmTQqIwCKYSiwidIrRKGA6G06
		q4Py0KNMBCARyfnEWK/Uj2hUyt5cr+5x4Lnlds1TygYQEtONmeq2ZHbVQOh2quGQbVddVBEAOw==
		""",

	"undo" : """
		R0lGODlhEAAQAKUxADFRlDFZtTFhtTlhpUJhpUJhtTlptUJptUJpxjFx50JxxkJx1kJ551J51lJ9
		tWt5rUp951p9xlp91lqCvVKC51KC91qG51KK92OS52OS92uW73Oa53Oa93Oi94yq1oSq95Sq95yu
		zoyy75Sy95y276W23q22zpy676W63qW676W+762+77XD763H77XH57XH77XL7///////////////
		/////////////////////////////////////////////yH5BAEKAD8ALAAAAAAQABAAAAZpwJ9w
		SCwaj0ihSrWCqZI/1YgkEq1YRZDwNdIsDgZI6kX8tGAjjAIxcRAuLeKG09EUCiHhAHIiYioZHQ9E
		CHxEFAkVHBiEFilEDAsIAgEAQwgXLlBCJQwZm0IRFyigJRcSpRcNJqUeoJtBADs=
		""",

	"redo" : """
		R0lGODlhEAAQAKU5ADFRlDFZtTFhtTlhpUJhpUJhtTlptUJptUJpxjFx50JxxkJx1kJ551J9tVJ5
		1kp952t5rVp9xlp91lqCvVKC51KC91qG51KK92OS52OS92uW73Oa53Oa93Oi94yq1oSq95Sq95yu
		zoyy75Sy95y276W23q22zpy676W63qW676W+77W+zq2+763D563H77XD77XH573H1rXH773H3rXL
		787X587X79bX3s7b7////////////////////////////yH5BAEKAD8ALAAAAAAQABAAAAZrwJ9w
		SCwaj8gfisZSJYUvlkhEGjmPstTDcFhoRjIhiOi6EBoThAIzork+xNNjMCwUNB3OJv5AECEdGRUY
		RCkWfkMYHBUJFEQwF4g/AAECCAsMRRkMKE9DKBcRnkMSFyWjPyYOF52oHq2oSEEAOw==
		""",

	"empty" : """
		R0lGODlhEAAQAIAAAP///////yH+JUNyZWF0ZWQgYnkgVmFzaWxpcy5WbGFjaG91ZGlzQGNlcm4u
		Y2gAIfkEAQoAAQAsAAAAABAAEAAAAg6Mj6nL7Q+jnLTai7M+BQA7
		""",

	"save" : """
		R0lGODlhEAAQAOcBAAAAAP//////////////////////////////////////////////////////
		/////////0xLS0RDRLO0ubO0ubO0ubO0ubS2ubS2u7a4vLe5vLi5vLm5vERDRExLS////////0JA
		QVpZWfH0+vD0+vD0+vD0+vH0+vL1+vP2+/X4/Pf5/Pn7/WVjZEJAQf///////0A+P2JgYfn6/Zy2
		z5y2z5y2z5y2z522z523z5630J+40P39/mJgYUA+P////////z08PV5cXfv8/fj5+/n5+/j5+/j5
		+/f4+vX3+vT2+fL0+PL2+V5cXT08Pf///////zs6O1tZWu7z9+/z9+/z9+/z9+7z9+7y9u3x9uvw
		9env9Oft81tZWjs6O////////zk3OFdVVuLq8YuiuIuiuIuiuIuiuIqht4qht4qgt4mgttzl7VdV
		Vjk3OP///////zc1NlRSU9Te6NDd6NDd6NDd6NDc58/c58/b587b5s3a5s/a5lRSUzc1Nv//////
		/zUzM1FOT1FOT1FOT1FOT1FOT1FOT1FOT1FOT1FOT1FOT1FOT1FOTzUzM////////zIwMU1KS01K
		S01KS01KS01KS01KS01KS01KS01KS01KS01KS01KSzIwMf///////zAtLklFRklFRs3NzdbW1tbV
		1dXV1dbW1tbW1tPT0ykmJyYjJElFRjAtLv///////yspKkI/QEI/QKenpz88PTUzM66urq6urq6u
		rq6urkJAQSgnJ0ZDRCspKv///////yYkJTs4OTs4OZmZmTQxMiglJp+fn5+fn5+fn5+fn0E+PyYk
		JVpXWCYkJf///////yQiIi0qKjUxMouKiysoKSEfIJCQkJCQkJCQkJCQkDYzNCEfIFFNTiMgIf//
		/////yUfHx8dHR4bHHV1dXh4eHh4eHh4eHh4eHh4eHh4eBsZGhsZGR8cHSEfH///////////////
		/////////////////////////////////////////////////////yH5BAEKAP8ALAAAAAAQABAA
		AAj4AP8JHEiwoMAIEiZQqGDhAoYMGjZw6OBBYAgRI0iUMHECRQoVK1i0cCEwhowZNGrYuIEjh44d
		PHr4EBhEyBAiRYwcQZJEyRImTZwIjCJlCpUqVq5gyaJlC5cuXgSGETOGTBkzZ9CkUbOGTRs3AuPI
		mUOnjp07ePLo2cOnjx+BgQQNIlTI0CFEiRQtYtTIkcBIkiZRqmTpEqZMmjZx6uRJYChRo0iVMnUK
		VSpVq1i1ciUwlqxZtGrZuoUrl65dvHr5EhhM2DBixYwdQ5ZM2TJmzZwJjCZtGrVq1q5hy6ZtG7du
		3gSGEzeOXDlz59ClU7eOXTt3BrMTDAgAOw==
		""",

	"load" : """
		R0lGODlhEAAQAMZPABAQECEQECEYEDEgITEwIUI4MVJJQmNJIWNZQmNhWnNhUnNlSlJplIRpIZRx
		IYRxUmN5lIR5Y6V5IZSCY7WCEJSKc4SKpZyKa5SKhMaKEISSpZSShMaSANaKEJyShKWShNaSAISa
		tdaSEKWahKWilLWihLWilOeiIeeiMbWqlNaqUveqMcaylNayc/eyMca6lLW6zrW+xve6QtbDhNbD
		lPfDQs7HtcbH1v/DUs7LtefLhMbP1v/LUv/TUv/TY+fTpffThP/Tc//bY/fbhNbb3v/bc//bhPfj
		lP/jhP/jlPfrpf/rpffzpffztf/zpf//////////////////////////////////////////////
		////////////////////////////////////////////////////////////////////////////
		/////////////////////////////////////////////////////////////////////////yH5
		BAEKAH8ALAAAAAAQABAAAAexgH+Cg4SFhoREGhYhMYeEEDCCGjsQfymXlzaGNwwMKT9NTU5LJjmF
		nQwmTKJLS0UkIyMfGxWDJkqjS0ZCvL21giRKrSwslyUlsR8fGBUjR0s6KUjT1EhFRSoezkkpL0W9
		Pj08MigLfx9D0UhBQj4+PDUyLg0X50ApNEXuPDjyKx0HBGGYIe0dPBcrTohokEBQBRMtQEjkkIEC
		BQkOAjqcEOGBAgQGChAYIABAAEcoBQUCADs=
		""",

	"sep" : """
		R0lGODlhAgARAKEDAFtZV6aioObi4P///yH5BAEKAAMALAAAAAACABEAAAIKTHACyusNXxCmAAA7
		""",

	"info" : """
		R0lGODlhEAAQAOfEAAAAADVZkSZeryRfsCZfsCtgriZisydjtCdmtyZtvCljsyhltShntyxptSho
		uClpuiprvCtsuChvvSpsvCptvipuvSpuvi1quS1sui5uvC5vvSdyvCZyvitwvy5wvjVqpztqpjxs
		tDByvCtwwStxwSxywSxywi5zwy50wjB1xDF1xDZ6xjd6xjh6xzl8yD18yD19yT59yFJoj01zqEx0
		skh5vlFwoVNxoFFxpFRyoFRyoll4qVt5qVN7t1Z/tFl+sGJ7pUB6wER7wkZ6wEZ7wEh7wEh9wk2B
		tEmAulCAtlGGulGGu1iEuV2Jt2qErmCDsGCDuW2IsXGHq3GKsnSQvniQtnyUukGAyUeEzEmEzE2G
		zk6IzlGEwVCExVCJx1CJz16LxFeN0liO0l+Qz2CMxWKMxWKNx2ONx2SKxGSNx2KRy2uY1G6Y026b
		2HSSwXeVw3OXzHueznydzXyezn6czH6fzn+ezn+fznCa1HGa1HKb1HCd03Ce2nCf3H+gz3Cg1nyn
		2nym3I2duI+hv5imu4OYwIKbw4Wdwoidw4Ch0Ieu3ous3Y2s3pCkypyqwJe23Ziw1Jiw15uy152y
		15qy2Juz2Jq23Jyz2J602JCw5JCx5JS05pS056KvyKSyyKu1xrbF37PF4rXF4bfG4rjH4brI4r/O
		5sDG1t/f38TV6szX6MzZ7dTd7NTe7Njg7tbg8tvi8Nrk8uTi4OTn7OTo7ejp7eDn8uDo9Orv9urw
		9urw+O7y+O7y+fH0+ff5+/b5/Pf5/Pf6/Pn7/Pr7/f//////////////////////////////////
		////////////////////////////////////////////////////////////////////////////
		////////////////////////////////////////////////////////////////////////////
		/////////////////////////////////////////////////////yH5BAEAAP8ALAAAAAAQABAA
		AAj6AP8JFNipUKNGiDwNXPgvh6FXrCKyWkXlBkMcoVyxgtXLFqtWriLZGKjjEqlRonYRGwZq1KhS
		dID8+wRlkiRJlEz5UgWp0k1MND4lgWPnjp85cRLVSZRIDpoQBQL4SFPmjBlLt3TxIlNEwQABBHwk
		qTGEiBEhj4gBa+CAwYIDBpJguIAhgwYPe4j9ikABwgMHCJRUkFChQwkUf9SKODHCwoQETapwMKGi
		xQtAxIIFgcEiBYkNVf4hcXElixZFxIR12YIlxoolAq14+SImUKxcuFKNCcOFiYyBh9TwaYNHTx42
		a/qA6cFwkBtGmjhtyrTojRSGAwseTMgwIAA7
		""",

	"cut" : """
		R0lGODlhEAAQAMZAACkoOSlBYzFBYzFBczlBYzFNYzFRhDFRlFpZY0JhnFJhc0JhtUphpUJpnFJp
		hEJptUJpxmNxhEp1xmt1hHN5e1J51lp91mt9rVKC53OClFKK51qG52uKxmuK1muW75SSpXua1pSa
		pYyavZSatZSetXum3oyi1pymvYym76WmraWutaWuzqWyxq2ytaWyzqW2zrWyxrW2vbW+xrW+zr2+
		xrW+3sbL1s7L1sbP3s7P3tbPztbTztbT1s7X59bX3tbX5///////////////////////////////
		////////////////////////////////////////////////////////////////////////////
		////////////////////////////////////////////////////////////////////////////
		/////////////////////////////////////////////////////////////////////////yH5
		BAEKAEAALAAAAAAQABAAAAd2gECCg4SFhTcthCmGhCGDMDSMgyMyghE7koIwH0A2CjqZQDMhKhkI
		oUA8GREKFKhAEwoOMaE/KBggFRYmNYw9HhsMCRIVECKMJRoPBxcVPi8HjBo5NtEVOScDjBg4KwZA
		HAsCAIwdCwcFQC4EASSMLA0EI6/0gQA7
		""",

	"copy" : """
		R0lGODlhEAAQAKU9ACFBhCFBlDFJYyFJlCFJpSFRpTFZtTFpxkJxxmNxlFJ5xmOCpVKC1mOK1mOS
		53OS1nOa1nOa53Oa93Oi55SitYSi55SqxoSq94Sy55Sq56WqxqWyxpSy95Sy/6Wy1pS696W656W6
		97W61qXD97XD1rXD57XD96XL/73H1r3L3rXL98bL1sbL587PzrXT/87P1sbT58bT99bT3s7X58bb
		/9bb59bb99bj9+fr9/fz9/fz//f7///7/////////////yH5BAEKAD8ALAAAAAAQABAAAAaUwJ9w
		SCz+SiUSSeSRGYelnrS3WbyeP9K0Z1klWk9Rj+a6UVQmU4jDmQ03Up4Op9peDimhpnf6YCYjWxIq
		Big/Fj07OTg3ID0dHTYOBgYFPxQ7fxMQGVM7ODEelhQ6NzUwLBU9FxEODAweBJcCtLQPUqUxJhsD
		Tw09rq8MGr1GCjseyRsaFgFPCJQFBQMDAQBY2NlGQQA7
		""",

	"paste" : """
		R0lGODlhEAAQAMZYAEI4IVJBMUI4lEJJUkpJY0JRUkpJa1JRUlJZY2NdUmNhY2NhhHNpUmNh1nNp
		hHNxc3NptXt1Y4RxY3N5hJR5QoR5hISChISKlJSKlJSKtbWSMZSKxqWSc6WaY5SSxpSS1pSWxqWa
		jJSS56WalJSaxqWapaWipcaqQrWulLWqtbWypb2ynMayhLWytcaynLW2tbW2vca6hNa6Y866lMa+
		vdbDlNbHnMbHztbLlMbL1s7L1tbPrc7L3ufTc+fLpdbL1ufThNbTtefTlOfTrdbX1ufblOfbpffb
		hOfbtd7bztbb5/fjhOfjtefb5/fjlOfj5/frpffrtffztf/ztffr9//7tf/7xv//xv//////////
		////////////////////////////////////////////////////////////////////////////
		/////////////////////////////////////////////////////////////////////////yH5
		BAEKAH8ALAAAAAAQABAAAAeUgH+Cg4SFhodKIBs6h4Q8HiIQDoZELZY3GR8NAgaFSS1PP08mJJsG
		MIQzLEgtVDlNFgsEL4JBNjFSV1dMJk8XKQcYgj5GVrq6VTgVJRMPBYJDQlHIU05HMQoWCgOENVFW
		UNY9Mh0IA7SDOzFFS0fjJxoBNIYuHEDvGgAjjSsSMvAAQjQShIIBhYADB6lIECGhQ0GBAAA7
		""",

	"paste32" : """
		R0lGODlhIAAgAOf7AF1pbWBqcGFscVptgWNscWFtcWFtc2NtcWRtc4FvUWJ0iGd3gm93gGl7jnN9
		hmx+kXR9h4R/ZHeAineCinqLnH6PoH+PoISQmZmSfYqWn62UbK2VbbeWZI6drZKfqZOfq5WgqLSd
		e5Oiq7eee5Sjspmirpilr5mlrpymssKjdMKkdcOldZ6rsKKrtsWnd5yswL+og7+ohcCohMWoeKOs
		uL+phL+phZ6twcCphcWpecapesCqhp+uwcGqh8eqesCrhp+vw8Grh6OvuMGriMaresKrh8ereqOw
		tsKsiMKsiaGwxMKticOtiqKxxcOuisOui8Sui8SujKWywKSyxcSvjcSwjcWwjsqydaW1yKa1yKe2
		yai3yqq4y6u6zay7zrC7ya28zr+6tK69z6++z7C+0LC+0bG/0d28b76/sLLA0bLA0r7BsMa/tcnC
		tNLEqNvGlsHJ0fPHZ/PHaPTHaPPIZ/PIaPPIafTIaPTIafTJafTJavTJa/XJavTKavTKa/XKa/XK
		bPXKbfbKbfXLbPXLbfXLbvbMb/bNcPbNcffNcPfNccLS4fbOcffOcffOcvfPc/fPdPjPc/jPdPfQ
		c/jQdPjQdcbX5dPX4dPY4tPZ4tTZ48zb6tba4tPb4tXb4tTb5tbb4fbZmNfb4tjb4dXc5/famffa
		mtnc4ffbmvjbnNrd4tvd4fjcnNLf7/jcndre4tze4fjdnd7e4fndnvndn97f4fnen/ren/reoN/g
		4eDg4Prfofrfovrfo9ji8fvgo/vho+jv+Ovw+efy//Dz+fHz+fHz+vD0+vH0+vL0+vL1+vL1+/P1
		+vP1+/P2+/T2+vT2+/X2+/X2/PT3+/X3+/X3/Pb3+/b3/PX4+/b4+/b4/Pf4/Pf5/Pf5/fj5/Pj6
		/Pj6/fn6/Pn6/fr6/fn7/fr7/fr7/vv7/fv7/vr8/fv8/fv8/vz8/fz8/v38/vz9/fz9/v39/v39
		//3+/v3+//7+/v7+///+/v/+//7//v7//////////////////////yH5BAEKAP8ALAAAAAAgACAA
		AAj+AP8JHEiwoMGDCBOCEMEiocOEJ+Ds27fg4cE2MGDUgCHDRgwbE/ZtSNBKwo8fPXoEGVKkCBuE
		MNwAA/ZrzZGbF/Yl0OALwoWbaG7ZmnWFCMIavyBVosRgotOJwzZZWmQCQZyrcYwc7TWJkiQH+4KV
		EEKjBQoPGdJ+IIA1jg+EOHhFevQIQwAAAvIKOGBAQIEAAiK01YFwB69GjhwxQmSo0CA/evDQaUs5
		B8IeuxIdUnSocSDIeOpQpjwDYRBchlI3FgQI8p05o9u6ME2rEKFCrP/s0ZOnjujYV1cgRDILkPHW
		fNSYKSMGTBfnXLZgmdLkqgqESWLt3tNHj500Tyf+6sNnz149JR3OpEDIxFWePN7x3DETvl4+8/Xm
		AZFiIQTCJan4VscddchBxkS65FKLgrXIEk88PHxCwgPssSLHhViN8RQ+9NQjTzzwtHODMKR8McBB
		TqAymhgTNQiLLLDAsko78LzQAQUKDHBiQU+oSBkY99xz34fwhLiOOuqUk0455exIEBSmjOYFPvms
		8sopr6hyyijnMElOOOWI4+RAUZQyWhf6mAciO+usg0455IwjzjfgfDOmQGWOxoV5o4gCiiicgOKJ
		Jp1kcgkm3nRz5z9UmEmZFmu2o4444oTzTTfaaHNNNZwuWoWjbUEKT59/BjpooYdKE82ijY6mhTuE
		kqZjDjjecJOpNdVMA40zzixqRSiuwrMOqYAKSqihmDTTjK9vuCopk+F4s0021EQDzTPOMLMMM4uG
		MQIH4IarxTvqEGvqsYcqk8yiCGnRzjpwimNrNdRA0wwzySiDjDHsHuRukuLUmg021zaTTDLFHENM
		vwZl0UEFDego8cQUW2SxQwEBADs=
		""",
	"tree_expanded" : """
		R0lGODlhEAANAKIAAAAAAMDAwICAgP//////ADAwMAAAAAAA
		ACH5BAEAAAEALAAAAAAQAA0AAAM6GCrM+jCIQamIbw6ybXNSx3GVB
		YRiygnA534Eq5UlO8jUqLYsquuy0+SXap1CxBHr+HoBjoGndDpNAAA7
		""",
	"tree_collapsed": """
		R0lGODlhDwANAKIAAAAAAMDAwICAgP//////ADAwMAAAAAAA
		ACH5BAEAAAEALAAAAAAPAA0AAAMyGCHM+lAMMoeAT9Jtm5NDKI4Wo
		FXcJphhipanq7Kvu8b1dLc5tcuom2foAQQAyKRSmQAAOw==
		""",
	"tree_regular" : """
		R0lGODlhCwAOAJEAAAAAAICAgP///8DAwCH5BAEAAAMALAAA
		AAALAA4AAAIphA+jA+JuVgtUtMQePJlWCgSN9oSTV5lkKQpo2q5W+
		wbzuJrIHgw1WgAAOw==
		""",
	"tree_plus" : """
		R0lGODdhCQAJAPEAAAAAAH9/f////wAAACwAAAAACQAJAAAC
		FIyPoiu2sJyCyoF7W3hxz850CFIA\nADs=
		""",
	"tree_minus" : """
		R0lGODdhCQAJAPEAAAAAAH9/f////wAAACwAAAAACQAJAAAC
		EYyPoivG614LAlg7ZZbxoR8UADs=
		""",
}

#-------------------------------------------------------------------------------
# @return icon from name
#-------------------------------------------------------------------------------
def get(name, *args):
	try:
		return _icons[name]
	except KeyError:
		if not args: raise

	for n in args:
		if n is None: return None
		try:
			return _icons[n]
		except KeyError:
			pass
	raise KeyError(f"icon '{name}' '{args}' not found")

#-------------------------------------------------------------------------------
# FIXME doesn't work? for modules
#-------------------------------------------------------------------------------
def __getitem__(name):
	return get(name)

#-------------------------------------------------------------------------------
def makeIcon(name, data):
	_icons[name] = tk.PhotoImage(data=data)

#-------------------------------------------------------------------------------
def loadIcon(filename, name=None):
	"""Load an icon from a gif or png file"""
	if name is None:
		name = os.path.splitext(os.path.basename(filename))[0]
	_icons[name] = tk.PhotoImage(file=filename)

#-------------------------------------------------------------------------------
def load(folder, ext=".gif"):
	"""Load all files with extension ext as icons from folder"""
	if not _icons: init()	# <<--- Initialize icons first time
	for img in glob.glob(f"{folder}/*{ext}"):
		loadIcon(img)

#-------------------------------------------------------------------------------
# Load aliases file
#-------------------------------------------------------------------------------
def loadAliases(aliases="aliases.db"):
	try:
		with open(aliases,"r") as f:
			for line in f:
				line = line.strip()
				if not line or line[:2]=="//": continue
				word = line.split()
				try:
					alias(word[0], word[1])
				except KeyError:
					log.error(f"icons.load alias of {word[0]!r}"
						f"-> {word[1]!r} not found")
		return True
	except IOError:
		return False

#-------------------------------------------------------------------------------
# Link source icon to destination
#-------------------------------------------------------------------------------
def alias(dst, src):
	if dst not in _icons:
		_icons[dst] = _icons[src]

#-------------------------------------------------------------------------------
def zoom(factor=1):
	"""Zoom all icons"""
	global _zoom
	if factor==_zoom: return
	f = int(factor / _zoom)
	_zoom = factor
	for name,icon in _icons.items():
		# FIXME maybe with PIL.Image we can use a more advanced zooming
		_icons[name] = icon.zoom(f)

#-------------------------------------------------------------------------------
def delete():
	"""Delete all icons should be called before exiting"""
	for icon in _icons.values():
		del icon
	_icons.clear()

#-------------------------------------------------------------------------------
def init():
	"""Initialize basic icons on first import"""
	if _icons: return False

	# Converted from GIF to base64 tk.PhotoImage
	# base64.encodestring(open(iconfile,"rb").read())

	# prepare default icons
	for name,data in __def_icons.items():
		makeIcon(name, data)
