# -*- coding: utf-8 -*-
#
# Copyright European Organization for Nuclear Research (CERN)
# All rights reserved
#
# Please look at the supplied documentation for the user's
# license
#
# Author: Vasilis.Vlachoudis@cern.ch
# Date:   16-Feb-2021

__author__ = "Vasilis Vlachoudis"
__email__  = "Vasilis.Vlachoudis@cern.ch"

from deck import Layout

from .input import Mcnp
from .card  import McnpCard

#===============================================================================
# Layout class for the specific input/canvas display
#===============================================================================
class McnpLayout(Layout):
	MODE = McnpCard.MODE

	# ----------------------------------------------------------------------
	def init(self):
		order = [
			#("STAB",      None),
			#("MATERIAL", _MATERIAL_layout),
			#("CELL",      _CELL_layout)
		]
		self._init_set(order, Mcnp.MODE)

	# ----------------------------------------------------------------------
	# Enable/disable caching of lists
	# ----------------------------------------------------------------------
	#def cache(self, on):
	#	super().cache(on)

	# ----------------------------------------------------------------------
	# Automatically detect type from range
	# ----------------------------------------------------------------------
	def iType(self, name, rng):
		try:
			if rng=="cell":
				return (name, McnpLayout.cellList)
			elif rng=="zaid":
				return (name, Mcnp.zaid)
			elif rng=="sab":
				return (name, Mcnp.sab)
			else:
				return super().iType(name,rng)
		except (TypeError,IndexError):
			return name

	#-----------------------------------------------------------------------
	def cellList(self):
		return self.typedefList("cell")
	regionList = cellList
