# -*- coding: utf-8 -*-
#
# Copyright European Organization for Nuclear Research (CERN)
# All rights reserved
#
# Please look at the supplied documentation for the user's
# license
#
# Author: Vasilis.Vlachoudis@cern.ch
# Date:   23-Nov-2018

import re

from deck import DeckConfig

#===============================================================================
# A container class to keep the programs
# It should contain only static and class methods
#===============================================================================
class PenelopeConfig(DeckConfig):
	SECTION     = "Penelope"	# Configuration section name
	version     = "Unknown"
	released    = ""
	directory   = ""		# Executable installation directory
	CYCLE       = "penelope_"	# prefix of temporary cycle directory
	DEFAULT_PRG = "penelope.sh"	# set in [flair.ini]
	DEFAULT_EXE = "penmain"		# set in [flair.ini]
	EXT         = ".in"		# default input extension
	EXTENSIONS  = [EXT]
	programs    = { "prg" : "",
			"exe" : ""
		}
	CYCLEDIR_PAT  = re.compile(rf"^{CYCLE}(\d+)$")
	CYCLEDIR2_PAT = re.compile(rf"^(.*/?){CYCLE}(\d+)$")

	#-----------------------------------------------------------------------
	# Load from config
	#-----------------------------------------------------------------------
	@staticmethod
	def loadConfig(config):
		section = PenelopeConfig.SECTION
		PenelopeConfig.setDir(config.getStr(section, "directory", ""))
		PenelopeConfig.setCmd("prg", config.getStr(section, "program",   PenelopeConfig.DEFAULT_PRG))
		PenelopeConfig.setCmd("exe", config.getStr(section, "executable",PenelopeConfig.DEFAULT_EXE))
